﻿#region License Information
/* HeuristicLab
 * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 *
 * This file is part of HeuristicLab.
 *
 * HeuristicLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * HeuristicLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
 */
#endregion

using System;
using System.Collections.Generic;
using System.Linq;
using HeuristicLab.Common;
using HeuristicLab.Core;

namespace HeuristicLab.Problems.DataAnalysis.Benchmarks {
  [Item("Rational polynomial (3d)", "")]
  public class RationalPolynomial : RegressionBenchmark {

    public RationalPolynomial() {
      //Name = "Rational polynomial (3d)";
      //TargetVariable = "y";

      //var inputVariables = new Dictionary<string, RandomDistribution>() {
      //  {"x1", new UniformalDistribution(0, 2)},
      //  {"x2", new UniformalDistribution(1, 2)},
      //  {"x3", new UniformalDistribution(1, 2)}
      //};

      //TestData = new DatasetDefinition(2667, inputVariables);
      //TrainingData = new DatasetDefinition(1333, inputVariables);
    }

    #region cloning
    protected RationalPolynomial(RationalPolynomial original, Cloner cloner)
      : base(original, cloner) {
    }

    public override IDeepCloneable Clone(Cloner cloner) {
      return new RationalPolynomial(this, cloner);
    }
    #endregion

    protected override double CalculateFunction(Dictionary<string, IList<double>> data) {
      double x1 = data[vars.ElementAt(0)].Last();
      double x2 = data[vars.ElementAt(1)].Last();
      double x3 = data[vars.ElementAt(2)].Last();
      return (30 * (x1 - 1) * (x3 - 1)) / ((x1 - 10) * Math.Pow(x2, 2));
    }

    public override List<string> InputVariable {
      get { throw new NotImplementedException(); }
    }

    public override string TargetVariable {
      get { throw new NotImplementedException(); }
    }

    public override Data.IntRange TrainingPartition {
      get { throw new NotImplementedException(); }
    }

    public override Data.IntRange TestPartition {
      get { throw new NotImplementedException(); }
    }

    protected override Dictionary<string, IList<double>> GenerateInput(Dictionary<string, IList<double>> data) {
      throw new NotImplementedException();
    }
  }
}
