﻿#region License Information
/* HeuristicLab
 * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 *
 * This file is part of HeuristicLab.
 *
 * HeuristicLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * HeuristicLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
 */
#endregion

using System;
using System.Collections.Generic;
using System.Linq;
using HeuristicLab.Common;
using HeuristicLab.Core;

namespace HeuristicLab.Problems.DataAnalysis.Benchmarks {
  [Item("UnwrappedBall function (1d)", "")]
  public class UnwrappedBallFunction : RegressionBenchmark {

    public UnwrappedBallFunction() {
      Name = "UnwrappedBall function (1d)";
      //TargetVariable = "y";
      //Inputvariables = new Dictionary<string, IntRange>() {
      //  {"x1", new IntRange(-2, 8)}
      //};
      //AmountOfPoints = 4000;
      //TrainingPartition = new IntRange(0, 2667);
      //TestPartition = new IntRange(TrainingPartition.End, AmountOfPoints);
    }

    #region cloning
    protected UnwrappedBallFunction(UnwrappedBallFunction original, Cloner cloner)
      : base(original, cloner) {
    }

    public override IDeepCloneable Clone(Cloner cloner) {
      return new UnwrappedBallFunction(this, cloner);
    }
    #endregion

    protected override double CalculateFunction(System.Collections.Generic.Dictionary<string, IList<double>> data, List<string> vars) {
      double x1 = data[vars.ElementAt(0)].Last();
      return 10 / (Math.Pow(x1 - 3, 2) + 5);
    }
  }
}
